#include "jde.h"
#include "seq.h"

int finish_flag=0; 

int seq_id=0; 
int seq_brothers[MAX_SCHEMAS];
arbitration seq_callforarbitration;
int seq_cycle=500; 

/*  NULL DRIVER INTERFACE */
/* DRIVER INTERFACE */

/* ----------------------------- DRIVER INTERFACE ------------------------- */
#define NAME "servos8"

typedef struct  {
  char pos[8];       /* Servo angular position (in degrees) [-90,90] */
  char enable[8];    /* Servo enabled/disabled                       */
} drv_interface;

drv_interface *interface;
/*--------------------------------------------------------------------------*/

void seq_iteration()
{
  static char seq1[]={0,45,45, 0};
  static char seq2[]={0,0 ,45,45};
  static int n=0;
  int size;
    
  size=sizeof(seq1)/sizeof(char);
  interface->pos[4] = seq1[n];
  interface->pos[5] = seq2[n];
  n = (n+1) % size;  
  
}

void seq_suspend()
{
  pthread_mutex_lock(&(all[seq_id].mymutex));
  put_state(seq_id,slept);
  printf("seq: off\n");
  interface->enable[0]=0;
  pthread_mutex_unlock(&(all[seq_id].mymutex));
} 


void seq_resume(int father, int *brothers, arbitration fn)
{
  int i;
 
  pthread_mutex_lock(&(all[seq_id].mymutex));
  /* this schema resumes its execution with no children at all */
  for(i=0;i<MAX_SCHEMAS;i++) all[seq_id].children[i]=FALSE;
 
  all[seq_id].father=father;
  if (brothers!=NULL) {
    for(i=0;i<MAX_SCHEMAS;i++) seq_brothers[i]=-1;
    i=0;
    while(brothers[i]!=-1) {seq_brothers[i]=brothers[i];i++;}
  }
  
  /* Import from null driver */
  interface=myimport(NAME, "interface");
  
  seq_callforarbitration=fn;
  put_state(seq_id,notready);
  printf("seq: on\n");
  interface->enable[0]=1;
  pthread_cond_signal(&(all[seq_id].condition));
  pthread_mutex_unlock(&(all[seq_id].mymutex));
} 

void *seq_thread(void *not_used) 
{
  struct timeval a,b;
  long diff, next;

  for(;finish_flag==0;) {
    pthread_mutex_lock(&(all[seq_id].mymutex));

    if (all[seq_id].state==slept) {
	    pthread_cond_wait(&(all[seq_id].condition),&(all[seq_id].mymutex));
	    pthread_mutex_unlock(&(all[seq_id].mymutex));
	  }
    else {
	    /* check preconditions. For now, preconditions are always satisfied*/
	    if (all[seq_id].state==notready) put_state(seq_id,ready);
      
      /* check brothers and arbitrate. For now this is the only winner */
	    else if (all[seq_id].state==ready) { 
	      put_state(seq_id,winner);
	    }	  
	    else if (all[seq_id].state==winner);

	    if (all[seq_id].state==winner) {
	      /* I'm the winner and must execute my iteration */
	      pthread_mutex_unlock(&(all[seq_id].mymutex));
	      gettimeofday(&a,NULL);
	      seq_iteration();
	      gettimeofday(&b,NULL);  

	      diff = (b.tv_sec-a.tv_sec)*1000000+b.tv_usec-a.tv_usec;
	      next = seq_cycle*1000-diff-10000; 
	      if (next>0) 
		      /* discounts 10ms taken by calling usleep itself */
		      usleep(seq_cycle*1000-diff);
	      else { 
		      /* just let this iteration go away. overhead time negligible */
		      printf("time interval violated: seq\n"); 
		      usleep(seq_cycle*1000);
		    }
	    }
	    else {
	      pthread_mutex_unlock(&(all[seq_id].mymutex));
	      usleep(seq_cycle*1000);
	    }
	  }
  }
  
  return NULL;
} 

void seq_stop()
{
  finish_flag=1;
  printf ("seq close\n");
}

void seq_startup(char *configfile)
{
  printf ("Config file: %s\n",configfile);
  
  pthread_mutex_lock(&(all[seq_id].mymutex));
  myexport("seq","id",&seq_id);
  printf("seq schema started up\n");
  put_state(seq_id,slept);
  pthread_create(&(all[seq_id].mythread),NULL,seq_thread,NULL);
  pthread_mutex_unlock(&(all[seq_id].mymutex));
}

void seq_guiresume()
{
  printf ("gui_resume\n");
}

void seq_guisuspend()
{
 printf ("gui_suspend\n");
}

